#pragma once
//#include "listbox.h"
#include "vbuttonwnd.h"
#define WM_NCCALCSIZE 0x0083


#define JOB_FILE_PATH TEXT(DATA_IN_PATH)

#define TAG_RTEPT L"<rtept"
#define TAG_RTEPT_END L"</rtept>"
#define TAG_RTEPT_EXT L"<extensions>"
#define TAG_RTEPT_EXT_END L"</extensions>"
#define TAG_RTEPT_TYPE L"<type"
#define TAG_RTEPT_TYPE_END L"</type>"

#define MASK_TYPE_REACHED 1
#define MASK_TYPE_INFO 2
#define MASK_TYPE_VIA 4
#define MASK_TYPE_POI 4
#define MASK_TYPE_SUBORDER  8
#define MASK_TYPE_DELIVER  16
#define MASK_TYPE_PICKUP 32
#define MASK_TYPE_ATTACHMENT 64


#define MASK_TYPE_REALPOS 0x00FF0000
#define MASK_TYPE_POSNUM  0xFF000000
#ifndef __VIR_LIST__
class CSimpleListCtrl : public CWindowImpl<CSimpleListCtrl, CListViewCtrl>, public CCustomDraw<CSimpleListCtrl>
{
    BEGIN_MSG_MAP(CSimpleListCtrl)
        CHAIN_MSG_MAP_ALT(CCustomDraw<CSimpleListCtrl>, 1)
		MESSAGE_HANDLER(WM_NCCALCSIZE ,OnNcCalcSize)
		MESSAGE_HANDLER(WM_LBUTTONDOWN ,OnLButtonDown)
		MESSAGE_HANDLER(WM_USER+1 ,OnInfo)
        DEFAULT_REFLECTION_HANDLER()
    END_MSG_MAP()
	CSimpleListCtrl(){
		Line1 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE1);
	//	Line2 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE2);
	//	Line3 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE3);
	//	Line4 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE4);
	//	Line5 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE5);
		LineS = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINES);
		hListBK= SHLoadImageResource (NULL,  IDB_BK_LISTE_PART);
		m_pszPath=NULL;
		m_nOff = 40 ; m_bType=0;m_pState=0;
	}
	~CSimpleListCtrl(){
		if(m_pszPath) free(m_pszPath); m_pszPath=NULL;
		DeleteObject(Line1);
	//	DeleteObject(Line2);
	//	DeleteObject(Line3);
	//	DeleteObject(Line4);
	//	DeleteObject(Line5);
		DeleteObject(LineS);
		DeleteObject(hListBK);
	}
 
    DWORD OnPrePaint(int idCtrl, LPNMCUSTOMDRAW lpNMCD){
    // Get notifications for every tree item being drawn.
    return CDRF_NOTIFYITEMDRAW;
};
    DWORD OnItemPrePaint(int idCtrl, LPNMCUSTOMDRAW lpNMCD){
    return CDRF_NOTIFYITEMDRAW;// CDRF_DODEFAULT;
};
	LRESULT OnNcCalcSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/){return 0;	};
 	bool HideScrollBar(int);
	LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnInfo(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
#if (_WIN32_IE >= 0x0400)
	DWORD OnSubItemPrePaint(int /*idCtrl*/, LPNMCUSTOMDRAW /*lpNMCustomDraw*/);
	
#endif // (_WIN32_IE >= 0x0400)
private:
	HBITMAP Line1;
//	HBITMAP Line2;
//	HBITMAP Line3;
//	HBITMAP Line4;
//	HBITMAP Line5;
	HBITMAP LineS;
public:
	HBITMAP hListBK;
	int m_nOff;
	TCHAR *m_pszPath;
	BOOL m_bNewStatus;
	int  m_bType;
	__CUSTOM_TYPE__  m_pState; 
};
#else
class CSimpleListCtrl :public CVirSimpleListCtrl
{
public:
	CSimpleListCtrl():CVirSimpleListCtrl()
	{
		// m_nOff=0;
		m_pszPath=0;
		 m_bNewStatus=0;
		  m_bType=0;
		  m_pState=0; 
	}
public:
	virtual BOOL InsertColumn(int nCol, const LVCOLUMN* pColumn)
	{
		if(nCol>=MAX_COLS) return 0;
		m_nColWidth[nCol] = pColumn->cx-m_nOff;
		if( m_nColWidth[0]>__POS_GREEN_MARK__-m_nOff) m_nColWidth[0]= __POS_GREEN_MARK__-m_nOff ;
		m_nCols = nCol+1;
		return 1;
	}
	virtual LRESULT OnLButtonDown(UINT, CPoint pt) ;
//	virtual LRESULT OnLButtonUp(UINT, CPoint pt) ;
	virtual DWORD DrawItem(HDC hDC , int nLine,CRect& rcPaint);
	//int m_nOff;
	TCHAR *m_pszPath;
	BOOL m_bNewStatus;
	int  m_bType;
	__CUSTOM_TYPE__  m_pState; 
};
#endif

#define NAVI_NORMAL 1
#define NAVI_ZU 2
#define NAVI_NACH 3
class VNewWnd : public VButtonWnd
{ 
public:
	enum { IDD = IDD_HELP };

 CpssScrollBar   cScrollBar;
	VNewWnd(int nBK,int icon,int bNewStatus=0):VButtonWnd(IDBI_BK_LISTE,0,icon)
    {

		m_nCount = 0;m_hfont=0;
		m_nSel = -1;
		m_bNewStatus = bNewStatus;
		m_bShowHidden = FALSE;m_bShowGreenMark=FALSE;
	}
	~VNewWnd()
	{
		if(m_hfont) DeleteObject(m_hfont);
	}

public:
	HFONT m_hfont;
	TCHAR m_szPath[128];
	int m_nCount , m_nSel;
	CSimpleListCtrl   m_ListBox;
	void CreateList(void);
	LRESULT doNaviZu(int bZu);
	int Alert(struct __JobState * pState);
	int m_bNewStatus;
	int m_bShowHidden,m_bShowGreenMark;
	int getPosNum(int nSel);
	int getRealPos(int nSel);
//void AddOneItem(TCHAR* inFileName,FILETIME* ptm,DWORD state);
void DataList(TCHAR*,BOOL)	;
virtual void OnPaintExt(HDC hDC,CRect& rcPaint);
//virtual void EnableScrollBtn(BOOL bErase=TRUE);
BEGIN_MSG_MAP(VNewWnd)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnErasebkgnd)
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
		MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove) 
		COMMAND_HANDLER(ID_CANCEL , BN_CLICKED,OnCancelMsg)
		COMMAND_HANDLER(IDS_NAVI_NACH , BN_CLICKED,OnNaviNach)
		COMMAND_HANDLER(IDS_NAVI_ZU , BN_CLICKED,OnNaviZu)	
		 MESSAGE_HANDLER(IDB_LISTSCOLL_BK ,OnScroll)
		COMMAND_HANDLER(IDB_SHOW_HIDDEN , BN_CLICKED,OnShowHidden)
		COMMAND_HANDLER(IDB_HIDE_HIDDEN , BN_CLICKED,OnHideHidden)

		COMMAND_HANDLER(IDB_CHECKMARK_GREEN , BN_CLICKED,OnShowGreenMark)
		COMMAND_HANDLER(IDB_CHECKMARK_GREEN_DIS , BN_CLICKED,OnHideGreenMark)

		NOTIFY_HANDLER(ID_LISTVIEW_ONKEY ,LVN_ITEMCHANGED , OnSelChanged)
		//COMMAND_HANDLER(ID_LSCROLL , BN_CLICKED,OnScroll)
			MESSAGE_HANDLER(WM_USER_CHANGE_SKIN,	OnChangeSkin)
			MESSAGE_HANDLER(WM_USER+1 ,	OnInfo)

		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
LRESULT OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);
LRESULT OnPaint(UINT /*uMsg*/, WPARAM /* wParam */, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnNaviNach(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnNaviZu(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnEnter(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnShowHidden(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnHideHidden(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);

	LRESULT OnShowGreenMark(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnHideGreenMark(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnInfo(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnScroll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);//LRESULT OnScroll(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSelChanged(int , LPNMHDR lParam, BOOL&);
};
BOOL IsPoiType(TCHAR*);
BOOL jobHasPOI(TCHAR* sPath);
void PlaySound(int nRes, BOOL bWait=0);